window.Gleam.initSearch([{"doc":"novdom","title":"novdom","content":"# novdom\n\n❗️❗️DISCLAIMER: This project is in a very early stage and is not ready for production use.❗️❗️\n\nAn easy to use frontend framework written in Gleam.\n\nNo use of a virtual DOM to ensure the best performance possible.\n\nUse [lustre_dev_tools](https://hexdocs.pm/lustre_dev_tools/index.html) for building / bundling and hot reloading.\n\n# prequisites\n\n- [gleam](https://gleam.run/getting-started/installing/)\n- [bun](https://bun.sh/docs/installation)\n- [nodejs](https://nodejs.org/en/download/prebuilt-installer) (for testing)\n\n# getting started\n\n- clone the repo\n- run `bun install`\n- run `gleam deps download`\n- go to `/examples/...` and run `gleam run -m lustre/dev start`\n\n# features / todos\n\n✅ = done \\\n⚠️ = done but needs improvement \\\n💼 = gets worked on / comming soon \\\n❌ = not implemented yet \\\n⁉️ = not sure when and how to implement\n\n- ✅ Components / Default HTML Components\n  - Keep Fn as Children?\n- ✅ Parameter / ⁉️ Modifier (have been postponed for now)\n  - Attributes (class, style, ... | -&gt; value | init values) / Listener (onclick, ... | -&gt; fn -&gt; Nil | can change state) / Modifier (onrender, ... | -&gt; fn -&gt; List(Paramenter) | modify init values)\n- ✅ State\n  - State Parameter (Attributes / Listener that can be changed on state change)\n  - State Components (Components that can be changed on state change)\n  - 💼 State Map Function / ListState Type?? \\\n    eg: \\\n    use ListStateItem(value) &lt;- state_list.map(State(List(value))) --&gt; List(Component) \\\n    // value: ListStateItem(a), new_value: a, index: Int \\\n    state_list.remove(value) \\\n    state_list.move(value, index) \\\n    state_list.insert_before(value, new_value) \\\n    state_list.insert_after(value, new_value) \\\n    state_list.replace(value, new_value)\n- ✅ Drag and Drop\n- 💼 Rich Text Editor\n- ❌ Router\n  - Make use of unrendered\n- ❌ Server Components\n- ❌ Resumability (like Qwik)\n\n- ⁉️ Backend (making use of Gleams compiling → Erlang / JavaScript)\n\n# Notes\n\n&lt;!-- - ondrag / ondrop motion callbacks need to return Parameter to update the component itself without state overhead\n- if some other component need to be changed on drag / drop motion, the state should be used --&gt;\n\n- state_components need render / unrender modifier to animate the change\n  unredner: unrender(List(Paramenter), UnrednderListener, NewRenderListener) -&gt; Modifier\n- HOW TO HANDLE A CHANGING STATE_COMP INSIDE A STATE_COMP? (the unrender of the parent comp could be called before the child comp is unrendered)\n  --&gt; chain listener: let chain: fn(Listener) -&gt; Listener = chain_listener.create(),\n\nTODO: Custom HTML Tags need a display attribute otherwise transform will not work\n\n\nComp Map Usage:\n- References\n- Modifier (onrender, onunrender)\n- ParamterContainer (ondrag, ondrop - unused, state_parameter)","url":"index.html"},{"doc":"novdom/parameter/listener","title":"global_listener","content":"pub const global_listener: fn(Parameter) -&gt; Nil\n\nSynonyms:\nnovdom/parameter/listener.global_listener\nnovdom/parameter/listener global_listener","url":"novdom/parameter/listener.html#global_listener"},{"doc":"novdom/parameter/listener","title":"once","content":"pub fn once(callback: fn(Event) -&gt; Nil) -&gt; fn(Event) -&gt; Nil\n Creates a callback that will remove the `Listener` from the `Component` after being called once.\n \n Example:\n \n div([\n   onclick(fn(_) { io.println(&quot;clicked&quot;) }), // This will be called every time the div is clicked\n   onclick(once(fn(_) { io.println(&quot;clicked once&quot;) })), // This will only be called once\n ], [])\n \nSynonyms:\nnovdom/parameter/listener.once\nnovdom/parameter/listener once","url":"novdom/parameter/listener.html#once"},{"doc":"novdom/parameter/listener","title":"onclick","content":"pub fn onclick(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;click&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onclick\nnovdom/parameter/listener onclick","url":"novdom/parameter/listener.html#onclick"},{"doc":"novdom/parameter/listener","title":"onkeydown","content":"pub fn onkeydown(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;keydown&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onkeydown\nnovdom/parameter/listener onkeydown","url":"novdom/parameter/listener.html#onkeydown"},{"doc":"novdom/parameter/listener","title":"onmousedown","content":"pub fn onmousedown(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;mousedown&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onmousedown\nnovdom/parameter/listener onmousedown","url":"novdom/parameter/listener.html#onmousedown"},{"doc":"novdom/parameter/listener","title":"onmousemove","content":"pub fn onmousemove(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;mousemove&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onmousemove\nnovdom/parameter/listener onmousemove","url":"novdom/parameter/listener.html#onmousemove"},{"doc":"novdom/parameter/listener","title":"onmouseout","content":"pub fn onmouseout(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;mouseout&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onmouseout\nnovdom/parameter/listener onmouseout","url":"novdom/parameter/listener.html#onmouseout"},{"doc":"novdom/parameter/listener","title":"onmouseover","content":"pub fn onmouseover(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;mouseover&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onmouseover\nnovdom/parameter/listener onmouseover","url":"novdom/parameter/listener.html#onmouseover"},{"doc":"novdom/parameter/listener","title":"onmouseup","content":"pub fn onmouseup(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;mouseup&quot; listener.\nSynonyms:\nnovdom/parameter/listener.onmouseup\nnovdom/parameter/listener onmouseup","url":"novdom/parameter/listener.html#onmouseup"},{"doc":"novdom/parameter/listener","title":"ontransitionend","content":"pub fn ontransitionend(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;transitionend&quot; listener.\nSynonyms:\nnovdom/parameter/listener.ontransitionend\nnovdom/parameter/listener ontransitionend","url":"novdom/parameter/listener.html#ontransitionend"},{"doc":"novdom/parameter/listener","title":"ontransitionstart","content":"pub fn ontransitionstart(callback: fn(Event) -&gt; Nil) -&gt; Parameter\n Returns a &quot;transitionstart&quot; listener.\nSynonyms:\nnovdom/parameter/listener.ontransitionstart\nnovdom/parameter/listener ontransitionstart","url":"novdom/parameter/listener.html#ontransitionstart"},{"doc":"novdom/parameter/listener","title":"novdom/parameter/listener","content":" Add an event listeners to a `Component`.","url":"novdom/parameter/listener.html"},{"doc":"novdom/hotkey","title":"Hotkey","content":"pub type Hotkey {\n  Hotkey(code: String, modifiers: List(Modifier))\n}\n Hotkey definition.\nHotkey(code: String, modifiers: List(Modifier))\n The *Code* needs to be the `event.code` from JavaScript (e.g. &quot;KeyB&quot;), see [https://keycode.info/](https://keycode.info/). \\\n The *Modifiers* are the additional keys that need to be pressed.\n\nSynonyms:\nnovdom/hotkey.Hotkey\nnovdom/hotkey Hotkey","url":"novdom/hotkey.html#Hotkey"},{"doc":"novdom/hotkey","title":"HotkeyId","content":"pub type HotkeyId =\n  String\n\n\nSynonyms:\nnovdom/hotkey.HotkeyId\nnovdom/hotkey HotkeyId","url":"novdom/hotkey.html#HotkeyId"},{"doc":"novdom/hotkey","title":"HotkeyOption","content":"pub type HotkeyOption {\n  Key(Hotkey)\n  Id(HotkeyId)\n}\n Options when adding a hotkey to a callback.\nKey(Hotkey)\n Add a hotkey directly.\n\nId(HotkeyId)\n Use an existing hotkey id.\n\nSynonyms:\nnovdom/hotkey.HotkeyOption\nnovdom/hotkey HotkeyOption","url":"novdom/hotkey.html#HotkeyOption"},{"doc":"novdom/hotkey","title":"Modifier","content":"pub type Modifier {\n  Shift\n  Alt\n  Short\n}\n Options for additional keys that need to be pressed.\nShift\n Shift key\n\nAlt\n Alt key\n\nShort\n Control key on Windows or Linux, Command key on macOS\n\nSynonyms:\nnovdom/hotkey.Modifier\nnovdom/hotkey Modifier","url":"novdom/hotkey.html#Modifier"},{"doc":"novdom/hotkey","title":"add","content":"pub fn add(id: String, key: Hotkey) -&gt; Nil\n Add a hotkey to a hotkey id.\nSynonyms:\nnovdom/hotkey.add\nnovdom/hotkey add","url":"novdom/hotkey.html#add"},{"doc":"novdom/hotkey","title":"configure_ids","content":"pub fn configure_ids(\n  config: List(#(String, List(Hotkey))),\n) -&gt; Nil\n Configure hotkeys with a list of hotkey ids and their corresponding hotkeys.\n Ids do not need to be unique and the same hotkey can be used for multible ids.\n \n This should be called once at the beginning of the application (rigth after `novdom.start(..)`).\n \n Example:\n \n hotkey.configure_ids([\n   #(&quot;bold&quot;, [Hotkey(&quot;KeyB&quot;, [Short])]),\n   #(&quot;italic&quot;, [Hotkey(&quot;KeyI&quot;, [Short])]),\n   #(&quot;underline&quot;, [Hotkey(&quot;KeyU&quot;, [Short])]),\n ])\n \nSynonyms:\nnovdom/hotkey.configure_ids\nnovdom/hotkey configure_ids","url":"novdom/hotkey.html#configure_ids"},{"doc":"novdom/hotkey","title":"get_ids","content":"pub fn get_ids(key: Hotkey) -&gt; List(String)\n Get all ids associated with a hotkey.\nSynonyms:\nnovdom/hotkey.get_ids\nnovdom/hotkey get_ids","url":"novdom/hotkey.html#get_ids"},{"doc":"novdom/hotkey","title":"get_keys","content":"pub fn get_keys(id: String) -&gt; List(Hotkey)\n Get all hotkeys associated with a hotkey id.\nSynonyms:\nnovdom/hotkey.get_keys\nnovdom/hotkey get_keys","url":"novdom/hotkey.html#get_keys"},{"doc":"novdom/hotkey","title":"init","content":"pub fn init() -&gt; Nil\n\nSynonyms:\nnovdom/hotkey.init\nnovdom/hotkey init","url":"novdom/hotkey.html#init"},{"doc":"novdom/hotkey","title":"override","content":"pub fn override(id: String, key: Hotkey) -&gt; Nil\n Overrides all hotkeys associated with the given id.\nSynonyms:\nnovdom/hotkey.override\nnovdom/hotkey override","url":"novdom/hotkey.html#override"},{"doc":"novdom/hotkey","title":"remove","content":"pub fn remove(id: String, key: Hotkey) -&gt; Nil\n Remove a hotkey from a hotkey id.\nSynonyms:\nnovdom/hotkey.remove\nnovdom/hotkey remove","url":"novdom/hotkey.html#remove"},{"doc":"novdom/hotkey","title":"with_hotkey","content":"pub fn with_hotkey(\n  option: HotkeyOption,\n  callback: fn(Event) -&gt; Nil,\n) -&gt; fn(Event) -&gt; Nil\n Add a hotkey to a callback.\n \n Example:\n \n onclick(with_hotkey(Key(Hotkey(&quot;KeyB&quot;, [Short])), fn(e) { ... }))\n onclick(with_hotkey(Id(&quot;bold&quot;), fn(e) { ... }))\n \nSynonyms:\nnovdom/hotkey.with_hotkey\nnovdom/hotkey with_hotkey","url":"novdom/hotkey.html#with_hotkey"},{"doc":"novdom/hotkey","title":"novdom/hotkey","content":"","url":"novdom/hotkey.html"},{"doc":"novdom/parameter/attribute","title":"class","content":"pub fn class(value: String) -&gt; Parameter\n Adding classes to the component. \\\n Concatenating the classes if the class attribute already exists.\nSynonyms:\nnovdom/parameter/attribute.class\nnovdom/parameter/attribute class","url":"novdom/parameter/attribute.html#class"},{"doc":"novdom/parameter/attribute","title":"editable","content":"pub fn editable() -&gt; Parameter\n Adding the contenteditable attribute to the component.\nSynonyms:\nnovdom/parameter/attribute.editable\nnovdom/parameter/attribute editable","url":"novdom/parameter/attribute.html#editable"},{"doc":"novdom/parameter/attribute","title":"style","content":"pub fn style(values: List(#(String, String))) -&gt; Parameter\n Adding inline-styles to the component. \\\n Overriding the style attribute if it already exists.\nSynonyms:\nnovdom/parameter/attribute.style\nnovdom/parameter/attribute style","url":"novdom/parameter/attribute.html#style"},{"doc":"novdom/parameter/attribute","title":"tailwind","content":"pub fn tailwind(value: String) -&gt; Parameter\n Adding tailwind classes to the component. \\\n Uses tailwind-merge to merge the classes if the class attribute already exists.\nSynonyms:\nnovdom/parameter/attribute.tailwind\nnovdom/parameter/attribute tailwind","url":"novdom/parameter/attribute.html#tailwind"},{"doc":"novdom/parameter/attribute","title":"novdom/parameter/attribute","content":"","url":"novdom/parameter/attribute.html"},{"doc":"novdom/component/html","title":"a","content":"pub fn a(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.a\nnovdom/component/html a","url":"novdom/component/html.html#a"},{"doc":"novdom/component/html","title":"custom","content":"pub fn custom(\n  tag: String,\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.custom\nnovdom/component/html custom","url":"novdom/component/html.html#custom"},{"doc":"novdom/component/html","title":"div","content":"pub fn div(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.div\nnovdom/component/html div","url":"novdom/component/html.html#div"},{"doc":"novdom/component/html","title":"h1","content":"pub fn h1(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.h1\nnovdom/component/html h1","url":"novdom/component/html.html#h1"},{"doc":"novdom/component/html","title":"h2","content":"pub fn h2(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.h2\nnovdom/component/html h2","url":"novdom/component/html.html#h2"},{"doc":"novdom/component/html","title":"h3","content":"pub fn h3(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.h3\nnovdom/component/html h3","url":"novdom/component/html.html#h3"},{"doc":"novdom/component/html","title":"p","content":"pub fn p(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.p\nnovdom/component/html p","url":"novdom/component/html.html#p"},{"doc":"novdom/component/html","title":"span","content":"pub fn span(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.span\nnovdom/component/html span","url":"novdom/component/html.html#span"},{"doc":"novdom/component/html","title":"td","content":"pub fn td(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.td\nnovdom/component/html td","url":"novdom/component/html.html#td"},{"doc":"novdom/component/html","title":"text","content":"pub fn text(\n  parameters: List(Parameter),\n  value: String,\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.text\nnovdom/component/html text","url":"novdom/component/html.html#text"},{"doc":"novdom/component/html","title":"textln","content":"pub fn textln(\n  parameters: List(Parameter),\n  value: String,\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.textln\nnovdom/component/html textln","url":"novdom/component/html.html#textln"},{"doc":"novdom/component/html","title":"tr","content":"pub fn tr(\n  parameters: List(Parameter),\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/html.tr\nnovdom/component/html tr","url":"novdom/component/html.html#tr"},{"doc":"novdom/component/html","title":"novdom/component/html","content":"","url":"novdom/component/html.html"},{"doc":"novdom/state","title":"State","content":"pub type State(a) {\n  State(state_id: StateId)\n  StateList(state_id: StateId)\n  StateItem(state_id: StateId, root_id: StateId)\n}\n **Attention:** Will be opaque soon.\nState(state_id: StateId)\n\n\nStateList(state_id: StateId)\n\n\nStateItem(state_id: StateId, root_id: StateId)\n\n\nSynonyms:\nnovdom/state.State\nnovdom/state State","url":"novdom/state.html#State"},{"doc":"novdom/state","title":"StateId","content":"pub type StateId =\n  String\n\n\nSynonyms:\nnovdom/state.StateId\nnovdom/state StateId","url":"novdom/state.html#StateId"},{"doc":"novdom/state","title":"create","content":"pub fn create(init: a) -&gt; State(a)\n Create a state with an initial value. \\\n If you want to create a state with a list, use `create_list(..)` - it is way more efficient plus you can use all `novdom/state/list` functions.\nSynonyms:\nnovdom/state.create\nnovdom/state create","url":"novdom/state.html#create"},{"doc":"novdom/state","title":"create_list","content":"pub fn create_list(init: List(a)) -&gt; State(List(a))\n Create a state with a list as an initial value. \\\n This enables all `novdom/state/list` functions.\nSynonyms:\nnovdom/state.create_list\nnovdom/state create_list","url":"novdom/state.html#create_list"},{"doc":"novdom/state","title":"create_list_with_id","content":"pub fn create_list_with_id(\n  id: String,\n  init: List(a),\n) -&gt; State(List(a))\n Create a state with a list as an initial value and a specific id. \\\n For more information, see `create_with_id(..)` and `create_list(..)`.\nSynonyms:\nnovdom/state.create_list_with_id\nnovdom/state create_list_with_id","url":"novdom/state.html#create_list_with_id"},{"doc":"novdom/state","title":"create_with_id","content":"pub fn create_with_id(id: String, init: a) -&gt; State(a)\n Create a state with a specific id. \\\n If a state with the same id already exists, it will be overwritten. \\\n To get a state with a specific id, use `from_id(..)`.\nSynonyms:\nnovdom/state.create_with_id\nnovdom/state create_with_id","url":"novdom/state.html#create_with_id"},{"doc":"novdom/state","title":"from_id","content":"pub fn from_id(id: String) -&gt; State(a)\n Get a state with a specific id. \\\n **Warning:** The state with this id needs to be created before (see `create_with_id(..)`). Otherwise this can lead to unexpected behavior.\nSynonyms:\nnovdom/state.from_id\nnovdom/state from_id","url":"novdom/state.html#from_id"},{"doc":"novdom/state","title":"list_from_id","content":"pub fn list_from_id(id: String) -&gt; State(List(a))\n Get a state with a specific id that holds a list value. \\\n For more information, see `from_id(..)`.\nSynonyms:\nnovdom/state.list_from_id\nnovdom/state list_from_id","url":"novdom/state.html#list_from_id"},{"doc":"novdom/state","title":"listen","content":"pub fn listen(state: State(a), callback: fn(a) -&gt; Nil) -&gt; Nil\n Listen to a state. \\\n The callback will be called whenever the state changes.\nSynonyms:\nnovdom/state.listen\nnovdom/state listen","url":"novdom/state.html#listen"},{"doc":"novdom/state","title":"update","content":"pub fn update(state: State(a), new: a) -&gt; Nil\n Update / overwrite the value of a state. \\\n If you want to update a `StateList`, see `novdom/state/list`.\nSynonyms:\nnovdom/state.update\nnovdom/state update","url":"novdom/state.html#update"},{"doc":"novdom/state","title":"value","content":"pub fn value(state: State(a)) -&gt; a\n Get the current value of a state.\nSynonyms:\nnovdom/state.value\nnovdom/state value","url":"novdom/state.html#value"},{"doc":"novdom/state","title":"novdom/state","content":"","url":"novdom/state.html"},{"doc":"novdom/state/component","title":"if1","content":"pub fn if1(\n  state state: State(a),\n  when should_show: fn(a) -&gt; Bool,\n  then component: Component,\n) -&gt; Component\n Shows or hides the given component based on the result of the *should_show* function.\nSynonyms:\nnovdom/state/component.if1\nnovdom/state/component if1","url":"novdom/state/component.html#if1"},{"doc":"novdom/state/component","title":"ternary1","content":"pub fn ternary1(\n  state state: State(a),\n  when should_show: fn(a) -&gt; Bool,\n  then component1: Component,\n  otherwiese component2: Component,\n) -&gt; Component\n Switches between the two given components based on the result of the *should_show* function.\nSynonyms:\nnovdom/state/component.ternary1\nnovdom/state/component ternary1","url":"novdom/state/component.html#ternary1"},{"doc":"novdom/state/component","title":"utilize","content":"pub fn utilize(\n  state: State(a),\n  do: fn(a) -&gt; Component,\n) -&gt; Component\n Rerenders the component using the *do* function on every state change.\n \n **Attention:** Use this function only as a last resort. Prefer `if(..)` or `ternary(..)` instead. To display every item of a list, use `novdom/state/list.map(..)`. \\\n All named alternatives are way more performant.\nSynonyms:\nnovdom/state/component.utilize\nnovdom/state/component utilize","url":"novdom/state/component.html#utilize"},{"doc":"novdom/state/component","title":"novdom/state/component","content":"","url":"novdom/state/component.html"},{"doc":"novdom/parameter/motion","title":"DragEvent","content":"pub type DragEvent(a) {\n  DragEvent(\n    value: a,\n    preview: Component,\n    drop: fn(DragEvent(a)) -&gt; Nil,\n    cancel: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n    droppable: Bool,\n  )\n}\n\nDragEvent(\n  value: a,\n  preview: Component,\n  drop: fn(DragEvent(a)) -&gt; Nil,\n  cancel: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n  droppable: Bool,\n)\n\n\nSynonyms:\nnovdom/parameter/motion.DragEvent\nnovdom/parameter/motion DragEvent","url":"novdom/parameter/motion.html#DragEvent"},{"doc":"novdom/parameter/motion","title":"PreviewType","content":"pub type PreviewType {\n  Preview(Component)\n  Self\n}\n\nPreview(Component)\n\n\nSelf\n\n\nSynonyms:\nnovdom/parameter/motion.PreviewType\nnovdom/parameter/motion PreviewType","url":"novdom/parameter/motion.html#PreviewType"},{"doc":"novdom/parameter/motion","title":"init","content":"pub fn init() -&gt; Nil\n\nSynonyms:\nnovdom/parameter/motion.init\nnovdom/parameter/motion init","url":"novdom/parameter/motion.html#init"},{"doc":"novdom/parameter/motion","title":"ondrag","content":"pub fn ondrag(\n  preview_type: PreviewType,\n  value: a,\n  on_drag: fn(DragEvent(a)) -&gt; Nil,\n  on_cancel: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n  on_drop: fn(DragEvent(a)) -&gt; Nil,\n) -&gt; Parameter\n\nSynonyms:\nnovdom/parameter/motion.ondrag\nnovdom/parameter/motion ondrag","url":"novdom/parameter/motion.html#ondrag"},{"doc":"novdom/parameter/motion","title":"ondrop","content":"pub fn ondrop(\n  on_drag: fn(DragEvent(a)) -&gt; Nil,\n  on_hover: fn(DragEvent(a)) -&gt; Bool,\n  on_drop: fn(DragEvent(a), fn() -&gt; Nil) -&gt; Nil,\n) -&gt; Parameter\n\nSynonyms:\nnovdom/parameter/motion.ondrop\nnovdom/parameter/motion ondrop","url":"novdom/parameter/motion.html#ondrop"},{"doc":"novdom/parameter/motion","title":"store_mouse_position","content":"pub fn store_mouse_position(event: Event) -&gt; Nil\n\nSynonyms:\nnovdom/parameter/motion.store_mouse_position\nnovdom/parameter/motion store_mouse_position","url":"novdom/parameter/motion.html#store_mouse_position"},{"doc":"novdom/parameter/motion","title":"novdom/parameter/motion","content":" **Warning:** This is still in development and should not be used yet.","url":"novdom/parameter/motion.html"},{"doc":"novdom","title":"start","content":"pub fn start(component: fn() -&gt; Component) -&gt; Nil\n Start the application. This function should be called in the main file of the application. \\\n The given component will be rendered in the viewport.\nSynonyms:\nnovdom.start\nnovdom start","url":"novdom.html#start"},{"doc":"novdom","title":"novdom","content":"","url":"novdom.html"},{"doc":"novdom/component/container","title":"Alignment","content":"pub type Alignment {\n  Top\n  Bottom\n  Left\n  Right\n  Center\n  TopLeft\n  TopRight\n  BottomLeft\n  BottomRight\n}\n\nTop\n\n\nBottom\n\n\nLeft\n\n\nRight\n\n\nCenter\n\n\nTopLeft\n\n\nTopRight\n\n\nBottomLeft\n\n\nBottomRight\n\n\nSynonyms:\nnovdom/component/container.Alignment\nnovdom/component/container Alignment","url":"novdom/component/container.html#Alignment"},{"doc":"novdom/component/container","title":"Direction","content":"pub type Direction {\n  VerticalDirection\n  HorizontalDirection\n}\n\nVerticalDirection\n\n\nHorizontalDirection\n\n\nSynonyms:\nnovdom/component/container.Direction\nnovdom/component/container Direction","url":"novdom/component/container.html#Direction"},{"doc":"novdom/component/container","title":"Scroll","content":"pub type Scroll {\n  VerticalScroll\n  HorizontalScroll\n  Scroll\n  NoScroll\n}\n\nVerticalScroll\n\n\nHorizontalScroll\n\n\nScroll\n\n\nNoScroll\n\n\nSynonyms:\nnovdom/component/container.Scroll\nnovdom/component/container Scroll","url":"novdom/component/container.html#Scroll"},{"doc":"novdom/component/container","title":"Spacing","content":"pub type Spacing {\n  Gap(String)\n  NoSpacing\n  EvenSpacing\n  BetweenSpacing\n  AroundSpacing\n}\n\nGap(String)\n\n\nNoSpacing\n\n\nEvenSpacing\n\n\nBetweenSpacing\n\n\nAroundSpacing\n\n\nSynonyms:\nnovdom/component/container.Spacing\nnovdom/component/container Spacing","url":"novdom/component/container.html#Spacing"},{"doc":"novdom/component/container","title":"hscroll","content":"pub fn hscroll(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/container.hscroll\nnovdom/component/container hscroll","url":"novdom/component/container.html#hscroll"},{"doc":"novdom/component/container","title":"hstack","content":"pub fn hstack(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/container.hstack\nnovdom/component/container hstack","url":"novdom/component/container.html#hstack"},{"doc":"novdom/component/container","title":"stack","content":"pub fn stack(\n  direction: Direction,\n  alignment: Alignment,\n  spacing: Spacing,\n  scrolling: Scroll,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/container.stack\nnovdom/component/container stack","url":"novdom/component/container.html#stack"},{"doc":"novdom/component/container","title":"vscroll","content":"pub fn vscroll(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/container.vscroll\nnovdom/component/container vscroll","url":"novdom/component/container.html#vscroll"},{"doc":"novdom/component/container","title":"vstack","content":"pub fn vstack(\n  alignment: Alignment,\n  spacing: Spacing,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/container.vstack\nnovdom/component/container vstack","url":"novdom/component/container.html#vstack"},{"doc":"novdom/component/container","title":"zstack","content":"pub fn zstack(\n  alignment: Alignment,\n  children: List(Component),\n) -&gt; Component\n\nSynonyms:\nnovdom/component/container.zstack\nnovdom/component/container zstack","url":"novdom/component/container.html#zstack"},{"doc":"novdom/component/container","title":"novdom/component/container","content":"","url":"novdom/component/container.html"},{"doc":"novdom/parameter/modifier","title":"RenderCall","content":"pub type RenderCall {\n  OnEnd\n  OnStart\n}\n Options for the `onreplacement` and `onchildren_replacement` modifier. This determines when the render function of the new component is called.\nOnEnd\n Render starts after the remove transition of the old component ends (so the old component is already removed).\n\nOnStart\n Render starts as soon as the remove transition of the old component starts (so both components are visible together).\n\nSynonyms:\nnovdom/parameter/modifier.RenderCall\nnovdom/parameter/modifier RenderCall","url":"novdom/parameter/modifier.html#RenderCall"},{"doc":"novdom/parameter/modifier","title":"onchildren_replace","content":"pub fn onchildren_replace(\n  parameters: List(Parameter),\n) -&gt; Parameter\n Add a modifier that fires when the children of the component are replaced.\n This can only be used on the `novdom/state/list.map(..)` component and will only fire when the full list is replaced (`novdom/state/list.update(..)`is called).\n \n **Attention:** The given parameters will apply directly on the children.\nSynonyms:\nnovdom/parameter/modifier.onchildren_replace\nnovdom/parameter/modifier onchildren_replace","url":"novdom/parameter/modifier.html#onchildren_replace"},{"doc":"novdom/parameter/modifier","title":"onchildren_replacement","content":"pub fn onchildren_replacement(\n  parameters: List(Parameter),\n  render_call: RenderCall,\n) -&gt; Parameter\n Add a modifier that fires when the children of the component are getting replaced.\n This can only be used on the `novdom/state/list.map(..)` component and will only fire when the full list is replaced (`novdom/state/list.update(..)`is called).\n \n **Attention:** The given parameters will apply directly on children if `OnStart` is used or apply on the parent if `OnEnd` is used (For tailwind use `[&amp;&gt;*&gt;*]:` to apply on children anyway). \\\n *This will be fixed as soons as possible.*\nSynonyms:\nnovdom/parameter/modifier.onchildren_replacement\nnovdom/parameter/modifier onchildren_replacement","url":"novdom/parameter/modifier.html#onchildren_replacement"},{"doc":"novdom/parameter/modifier","title":"oninsert","content":"pub fn oninsert(parameters: List(Parameter)) -&gt; Parameter\n Add a modifier that fires when the component is inserted to a list. \n See `novdom/state/list.insert(..)` for more information.\n \n This will also fire when the component is initially rendered and no `onrender` modifier is present. \\\n If `oninsert` and `onreplace` are both present, the first modifier added will determine the the `onrender` behavior.\nSynonyms:\nnovdom/parameter/modifier.oninsert\nnovdom/parameter/modifier oninsert","url":"novdom/parameter/modifier.html#oninsert"},{"doc":"novdom/parameter/modifier","title":"onremove","content":"pub fn onremove(parameters: List(Parameter)) -&gt; Parameter\n Add a modifier that fires when the component is removed from a list.\n See `novdom/state/list.remove(..)` or `novdom/state/component.if(..)` for more information.\nSynonyms:\nnovdom/parameter/modifier.onremove\nnovdom/parameter/modifier onremove","url":"novdom/parameter/modifier.html#onremove"},{"doc":"novdom/parameter/modifier","title":"onrender","content":"pub fn onrender(parameters: List(Parameter)) -&gt; Parameter\n Add a modifier that fires when the component is initially rendered.\nSynonyms:\nnovdom/parameter/modifier.onrender\nnovdom/parameter/modifier onrender","url":"novdom/parameter/modifier.html#onrender"},{"doc":"novdom/parameter/modifier","title":"onreplace","content":"pub fn onreplace(parameters: List(Parameter)) -&gt; Parameter\n Add a modifier that fires when the component replaces another component.\n See `novdom/state/list.replace(..)`, `novdom/state/component.ternary(..)`, or `novdom/state/component.utilize(..)` for more information.\n \n This will also fire when the component is initially rendered and no `onrender` modifier is present. \\\n If `oninsert` and `onreplace` are both present, the first modifier added will determine the the `onrender` behavior.\n \n Furthermore, this will also fire when used as a list item, no `onchildren_replace` is present and the list is replaced.\n See `onchildren_replacement(..)` or `onchildren_replace(..)` for more information.\nSynonyms:\nnovdom/parameter/modifier.onreplace\nnovdom/parameter/modifier onreplace","url":"novdom/parameter/modifier.html#onreplace"},{"doc":"novdom/parameter/modifier","title":"onreplace_insert","content":"pub fn onreplace_insert() -&gt; Parameter\n Add a modifier that fires the used `oninsert` modifier when the component replaces another component.\nSynonyms:\nnovdom/parameter/modifier.onreplace_insert\nnovdom/parameter/modifier onreplace_insert","url":"novdom/parameter/modifier.html#onreplace_insert"},{"doc":"novdom/parameter/modifier","title":"onreplacement","content":"pub fn onreplacement(\n  parameters: List(Parameter),\n  render_call: RenderCall,\n) -&gt; Parameter\n Add a modifier that fires when the component is replaced by another component.\n See `novdom/state/list.replace(..)`, `novdom/state/component.ternary(..)`, or `novdom/state/component.utilize(..)` for more information.\n \n The *render_call* determines when the render function of the new component is called.\n \n This will also fire when the component is removed and no `onremove` modifier is present.\nSynonyms:\nnovdom/parameter/modifier.onreplacement\nnovdom/parameter/modifier onreplacement","url":"novdom/parameter/modifier.html#onreplacement"},{"doc":"novdom/parameter/modifier","title":"onreplacement_remove","content":"pub fn onreplacement_remove(render_call: RenderCall) -&gt; Parameter\n Add a modifier that fires the used `onreplace` modifier when the component is replaced by another component.\n \n The *render_call* determines when the render function of the new component is called.\nSynonyms:\nnovdom/parameter/modifier.onreplacement_remove\nnovdom/parameter/modifier onreplacement_remove","url":"novdom/parameter/modifier.html#onreplacement_remove"},{"doc":"novdom/parameter/modifier","title":"translate_onchildren_change","content":"pub fn translate_onchildren_change(\n  transition transition: Parameter,\n) -&gt; Parameter\n Translates the children if they change in some way (e.g. if some are inserted, moved or deleted).\n This can only be used on the `novdom/state/list.map(..)` component.\n \n Pass an `Attribute` that applies a transition that is used.\nSynonyms:\nnovdom/parameter/modifier.translate_onchildren_change\nnovdom/parameter/modifier translate_onchildren_change","url":"novdom/parameter/modifier.html#translate_onchildren_change"},{"doc":"novdom/parameter/modifier","title":"novdom/parameter/modifier","content":" Add `Parameter` to a `Component` when a specific `State` Event occurs.\n \n Use this in combinations with `novdom/state/component` or `novdom/state/list`.","url":"novdom/parameter/modifier.html"},{"doc":"novdom/position","title":"novdom/position","content":" This may be implemented in the future.","url":"novdom/position.html"},{"doc":"novdom/reference","title":"Reference","content":"pub opaque type Reference\n\n\nSynonyms:\nnovdom/reference.Reference\nnovdom/reference Reference","url":"novdom/reference.html#Reference"},{"doc":"novdom/reference","title":"ReferenceType","content":"pub type ReferenceType {\n  Value\n  InnerHTML\n}\n Options for the reference type.\nValue\n Reference the component&#39;s value. (Useful for input fields)\n\nInnerHTML\n Reference the component&#39;s inner HTML. (Useful for divs, spans, etc.)\n\nSynonyms:\nnovdom/reference.ReferenceType\nnovdom/reference ReferenceType","url":"novdom/reference.html#ReferenceType"},{"doc":"novdom/reference","title":"create","content":"pub fn create() -&gt; Reference\n Create a new reference. \\\n The reference still needs to be set to a component.\nSynonyms:\nnovdom/reference.create\nnovdom/reference create","url":"novdom/reference.html#create"},{"doc":"novdom/reference","title":"set","content":"pub fn set(ref: Reference, ref_type: ReferenceType) -&gt; Parameter\n Set the reference to a component. See `ReferenceType` for more information.\nSynonyms:\nnovdom/reference.set\nnovdom/reference set","url":"novdom/reference.html#set"},{"doc":"novdom/reference","title":"value","content":"pub fn value(ref: Reference) -&gt; String\n Read the reference&#39;s value.\nSynonyms:\nnovdom/reference.value\nnovdom/reference value","url":"novdom/reference.html#value"},{"doc":"novdom/reference","title":"novdom/reference","content":" Reference a component. This is way less overhead than using a `State` for this purpose.","url":"novdom/reference.html"},{"doc":"novdom/rich_text","title":"Delta","content":"pub type Delta\n\n\nSynonyms:\nnovdom/rich_text.Delta\nnovdom/rich_text Delta","url":"novdom/rich_text.html#Delta"},{"doc":"novdom/rich_text","title":"Format","content":"pub type Format {\n  Bold\n  Italic\n  Underline\n}\n\nBold\n\n\nItalic\n\n\nUnderline\n\n\nSynonyms:\nnovdom/rich_text.Format\nnovdom/rich_text Format","url":"novdom/rich_text.html#Format"},{"doc":"novdom/rich_text","title":"Quill","content":"pub type Quill\n\n\nSynonyms:\nnovdom/rich_text.Quill\nnovdom/rich_text Quill","url":"novdom/rich_text.html#Quill"},{"doc":"novdom/rich_text","title":"RichTextStore","content":"pub opaque type RichTextStore\n\n\nSynonyms:\nnovdom/rich_text.RichTextStore\nnovdom/rich_text RichTextStore","url":"novdom/rich_text.html#RichTextStore"},{"doc":"novdom/rich_text","title":"delta","content":"pub fn delta(store: RichTextStore) -&gt; Delta\n\nSynonyms:\nnovdom/rich_text.delta\nnovdom/rich_text delta","url":"novdom/rich_text.html#delta"},{"doc":"novdom/rich_text","title":"editor","content":"pub fn editor(store: RichTextStore) -&gt; Component\n\nSynonyms:\nnovdom/rich_text.editor\nnovdom/rich_text editor","url":"novdom/rich_text.html#editor"},{"doc":"novdom/rich_text","title":"format","content":"pub fn format(store: RichTextStore, format: Format) -&gt; Delta\n\nSynonyms:\nnovdom/rich_text.format\nnovdom/rich_text format","url":"novdom/rich_text.html#format"},{"doc":"novdom/rich_text","title":"store","content":"pub fn store() -&gt; RichTextStore\n\nSynonyms:\nnovdom/rich_text.store\nnovdom/rich_text store","url":"novdom/rich_text.html#store"},{"doc":"novdom/rich_text","title":"text","content":"pub fn text(store: RichTextStore) -&gt; String\n\nSynonyms:\nnovdom/rich_text.text\nnovdom/rich_text text","url":"novdom/rich_text.html#text"},{"doc":"novdom/rich_text","title":"novdom/rich_text","content":" An interface to the Quill rich text editor. See [https://quilljs.com/](https://quilljs.com/) for more information.\n \n **Warning:** This is still in development and should not be used yet.","url":"novdom/rich_text.html"},{"doc":"novdom/state/list","title":"create","content":"pub fn create(init: List(a)) -&gt; State(List(a))\n Alias for `novdom/state.create_list(..)`\nSynonyms:\nnovdom/state/list.create\nnovdom/state/list create","url":"novdom/state/list.html#create"},{"doc":"novdom/state/list","title":"delete","content":"pub fn delete(item: State(a)) -&gt; Nil\n Delete this item from its list.\n \n **Attention:** Only call this function if the item is a `StateItem` (derived from `map(..)` or `get(..)`).\nSynonyms:\nnovdom/state/list.delete\nnovdom/state/list delete","url":"novdom/state/list.html#delete"},{"doc":"novdom/state/list","title":"get","content":"pub fn get(\n  from: State(List(a)),\n  idx: Int,\n) -&gt; Result(State(a), Nil)\n Get an item from a list. Returns an Error if the given index is out of bounds.\n \n **Attention:** Only call this function if the given state is a `StateList`.\nSynonyms:\nnovdom/state/list.get\nnovdom/state/list get","url":"novdom/state/list.html#get"},{"doc":"novdom/state/list","title":"insert_after","content":"pub fn insert_after(item: State(a), value: a) -&gt; Nil\n Insert a new value into the list after this item.\n \n **Attention:** Only call this function if the item is a `StateItem` (derived from `map(..)` or `get(..)`).\nSynonyms:\nnovdom/state/list.insert_after\nnovdom/state/list insert_after","url":"novdom/state/list.html#insert_after"},{"doc":"novdom/state/list","title":"insert_before","content":"pub fn insert_before(item: State(a), value: a) -&gt; Nil\n Insert a new value into the list before this item.\n \n **Attention:** Only call this function if the item is a `StateItem` (derived from `map(..)` or `get(..)`).\nSynonyms:\nnovdom/state/list.insert_before\nnovdom/state/list insert_before","url":"novdom/state/list.html#insert_before"},{"doc":"novdom/state/list","title":"map","content":"pub fn map(\n  parameter: List(Parameter),\n  state_list: State(List(a)),\n  do: fn(State(a)) -&gt; Component,\n) -&gt; Component\n Create a component that renders a list of items. \\\n Whenever all items of a list need to be rendered, this function is way more efficient than using `novdom/state/component.utilize(..)`.\n \n The *do* function is called for each item in the list. \\\n This will create a new state for each item, so you can listen to each item individually (e.g. by using `novdom/state/component`).\n \n Example:\n \n use item &lt;- state_list.map([], my_list)\n div([tailwind(&quot;p-5 bg-blue-100&quot;)], [\n     {\n         use value &lt;- state_component.utilize(item)\n         text([], value)\n     }\n ])\n \n **Attention:** Only call this function if the given state is a `StateList`.\nSynonyms:\nnovdom/state/list.map\nnovdom/state/list map","url":"novdom/state/list.html#map"},{"doc":"novdom/state/list","title":"move_after","content":"pub fn move_after(this: State(a), after: State(a)) -&gt; Nil\n Move this item after another item in the same list.\n \n **Attention:** Only call this function if both items are `StateItems` (derived from `map(..)` or `get(..)`) and they are in the same list.\nSynonyms:\nnovdom/state/list.move_after\nnovdom/state/list move_after","url":"novdom/state/list.html#move_after"},{"doc":"novdom/state/list","title":"move_before","content":"pub fn move_before(this: State(a), before: State(a)) -&gt; Nil\n Move this item before another item in the same list.\n \n **Attention:** Only call this function if both items are `StateItems` (derived from `map(..)` or `get(..)`) and they are in the same list.\nSynonyms:\nnovdom/state/list.move_before\nnovdom/state/list move_before","url":"novdom/state/list.html#move_before"},{"doc":"novdom/state/list","title":"replace","content":"pub fn replace(item: State(a), new: a) -&gt; Nil\n Replace this item with a new value.\n \n **Attention:** Only call this function if the item is a `StateItem` (derived from `map(..)` or `get(..)`).\nSynonyms:\nnovdom/state/list.replace\nnovdom/state/list replace","url":"novdom/state/list.html#replace"},{"doc":"novdom/state/list","title":"update","content":"pub fn update(state_: State(List(a)), new: List(a)) -&gt; Nil\n Alias for `novdom/state.update(..)`\nSynonyms:\nnovdom/state/list.update\nnovdom/state/list update","url":"novdom/state/list.html#update"},{"doc":"novdom/state/list","title":"value","content":"pub fn value(state_: State(List(a))) -&gt; List(a)\n Alias for `novdom/state.value(..)`\nSynonyms:\nnovdom/state/list.value\nnovdom/state/list value","url":"novdom/state/list.html#value"},{"doc":"novdom/state/list","title":"novdom/state/list","content":" Work with lists of items in a state (`StateList`). \\\n (Created with `create(..)`, `novdom/state.create_list(..)`, `novdom/state.create_list_with_id(..)` or `novdom/state.list_from_id(..)`)","url":"novdom/state/list.html"},{"doc":"novdom/state/parameter","title":"if1","content":"pub fn if1(\n  state state: State(a),\n  when when: fn(a) -&gt; Bool,\n  then parameters: List(Parameter),\n) -&gt; Parameter\n Applies or removes the given parameter based on the result of the *when* function.\nSynonyms:\nnovdom/state/parameter.if1\nnovdom/state/parameter if1","url":"novdom/state/parameter.html#if1"},{"doc":"novdom/state/parameter","title":"if2","content":"pub fn if2(\n  state1 state1: State(a),\n  state2 state2: State(b),\n  when when: fn(a, b) -&gt; Bool,\n  then parameters: List(Parameter),\n) -&gt; Parameter\n Applies or removes the given parameter based on the result of the *when* function.\nSynonyms:\nnovdom/state/parameter.if2\nnovdom/state/parameter if2","url":"novdom/state/parameter.html#if2"},{"doc":"novdom/state/parameter","title":"ternary1","content":"pub fn ternary1(\n  state state: State(a),\n  when when: fn(a) -&gt; Bool,\n  then parameters1: List(Parameter),\n  otherwise parameters2: List(Parameter),\n) -&gt; Parameter\n Switches between the two given parameters based on the result of the *when* function.\nSynonyms:\nnovdom/state/parameter.ternary1\nnovdom/state/parameter ternary1","url":"novdom/state/parameter.html#ternary1"},{"doc":"novdom/state/parameter","title":"utilize","content":"pub fn utilize(\n  state: State(a),\n  do: fn(a) -&gt; List(Parameter),\n) -&gt; Parameter\n Recalculates the given parameters using the *do* function based on the current state value.\nSynonyms:\nnovdom/state/parameter.utilize\nnovdom/state/parameter utilize","url":"novdom/state/parameter.html#utilize"},{"doc":"novdom/state/parameter","title":"novdom/state/parameter","content":" Apply parameters to components based on a state.\n \n **Attention:** Only `Attribute` and `Listener` parameters are allowed.","url":"novdom/state/parameter.html"},{"doc":"novdom_testing/component_should","title":"attribute","content":"pub fn attribute(component: Component, name: String) -&gt; String\n Returns the value of an attribute\nSynonyms:\nnovdom_testing/component_should.attribute\nnovdom_testing/component_should attribute","url":"novdom_testing/component_should.html#attribute"},{"doc":"novdom_testing/component_should","title":"be_hidden","content":"pub fn be_hidden(component: Component) -&gt; Component\n Check if a component is hidden from the user. This is the opposite of `be_visible`\nSynonyms:\nnovdom_testing/component_should.be_hidden\nnovdom_testing/component_should be_hidden","url":"novdom_testing/component_should.html#be_hidden"},{"doc":"novdom_testing/component_should","title":"be_visible","content":"pub fn be_visible(component: Component) -&gt; Component\n Check if a component is visible to the user.\nSynonyms:\nnovdom_testing/component_should.be_visible\nnovdom_testing/component_should be_visible","url":"novdom_testing/component_should.html#be_visible"},{"doc":"novdom_testing/component_should","title":"exclusively_show_text","content":"pub fn exclusively_show_text(\n  component: Component,\n  text: String,\n) -&gt; Component\n Check if a component exclusively shows a specific text.\nSynonyms:\nnovdom_testing/component_should.exclusively_show_text\nnovdom_testing/component_should exclusively_show_text","url":"novdom_testing/component_should.html#exclusively_show_text"},{"doc":"novdom_testing/component_should","title":"have_attribute","content":"pub fn have_attribute(\n  component: Component,\n  attribute: Parameter,\n) -&gt; Component\n Check if a component has a specific attribute.\nSynonyms:\nnovdom_testing/component_should.have_attribute\nnovdom_testing/component_should have_attribute","url":"novdom_testing/component_should.html#have_attribute"},{"doc":"novdom_testing/component_should","title":"have_child","content":"pub fn have_child(\n  parent: Component,\n  child: Component,\n) -&gt; Component\n Check if a component has a specific child.\nSynonyms:\nnovdom_testing/component_should.have_child\nnovdom_testing/component_should have_child","url":"novdom_testing/component_should.html#have_child"},{"doc":"novdom_testing/component_should","title":"have_listener","content":"pub fn have_listener(\n  component: Component,\n  listener_fn: fn(fn(Event) -&gt; Nil) -&gt; Parameter,\n) -&gt; Component\n Check if a component has a specific listener (callback is not checked). \\\n If a specific callback needs to be checked, use `have_listener_callback`.\nSynonyms:\nnovdom_testing/component_should.have_listener\nnovdom_testing/component_should have_listener","url":"novdom_testing/component_should.html#have_listener"},{"doc":"novdom_testing/component_should","title":"have_listener_callback","content":"pub fn have_listener_callback(\n  component: Component,\n  listener: Parameter,\n) -&gt; Component\n Check if a component has a specific listener with a specific callback. \\\n If only the listener needs to be checked, use `have_listener`.\nSynonyms:\nnovdom_testing/component_should.have_listener_callback\nnovdom_testing/component_should have_listener_callback","url":"novdom_testing/component_should.html#have_listener_callback"},{"doc":"novdom_testing/component_should","title":"have_tag","content":"pub fn have_tag(component: Component, tag: String) -&gt; Component\n Check if a component has a specific HTML tag.\nSynonyms:\nnovdom_testing/component_should.have_tag\nnovdom_testing/component_should have_tag","url":"novdom_testing/component_should.html#have_tag"},{"doc":"novdom_testing/component_should","title":"not_have_attribute","content":"pub fn not_have_attribute(\n  component: Component,\n  attribute: Parameter,\n) -&gt; Component\n Check if a component does not have a specific attribute. This is the opposite of `have_attribute`\nSynonyms:\nnovdom_testing/component_should.not_have_attribute\nnovdom_testing/component_should not_have_attribute","url":"novdom_testing/component_should.html#not_have_attribute"},{"doc":"novdom_testing/component_should","title":"not_have_child","content":"pub fn not_have_child(\n  parent: Component,\n  child: Component,\n) -&gt; Component\n Check if a component does not have a specific child. This is the opposite of `have_child`\nSynonyms:\nnovdom_testing/component_should.not_have_child\nnovdom_testing/component_should not_have_child","url":"novdom_testing/component_should.html#not_have_child"},{"doc":"novdom_testing/component_should","title":"not_have_listener","content":"pub fn not_have_listener(\n  component: Component,\n  listener_fn: fn(fn(Event) -&gt; Nil) -&gt; Parameter,\n) -&gt; Component\n Check if a component does not have a specific listener. This is the opposite of `have_listener`\nSynonyms:\nnovdom_testing/component_should.not_have_listener\nnovdom_testing/component_should not_have_listener","url":"novdom_testing/component_should.html#not_have_listener"},{"doc":"novdom_testing/component_should","title":"not_have_listener_callback","content":"pub fn not_have_listener_callback(\n  component: Component,\n  listener: Parameter,\n) -&gt; Component\n Check if a component does not have a specific listener with a specific callback. This is the opposite of `have_listener_callback`\nSynonyms:\nnovdom_testing/component_should.not_have_listener_callback\nnovdom_testing/component_should not_have_listener_callback","url":"novdom_testing/component_should.html#not_have_listener_callback"},{"doc":"novdom_testing/component_should","title":"not_have_tag","content":"pub fn not_have_tag(\n  component: Component,\n  tag: String,\n) -&gt; Component\n Check if a component does not have a specific HTML tag. This is the opposite of `have_tag`\nSynonyms:\nnovdom_testing/component_should.not_have_tag\nnovdom_testing/component_should not_have_tag","url":"novdom_testing/component_should.html#not_have_tag"},{"doc":"novdom_testing/component_should","title":"not_show_text","content":"pub fn not_show_text(\n  component: Component,\n  text: String,\n) -&gt; Component\n Check if a component does not show a specific text. This is the opposite of `show_text`\nSynonyms:\nnovdom_testing/component_should.not_show_text\nnovdom_testing/component_should not_show_text","url":"novdom_testing/component_should.html#not_show_text"},{"doc":"novdom_testing/component_should","title":"show_text","content":"pub fn show_text(component: Component, text: String) -&gt; Component\n Check if a component shows a specific text.\nSynonyms:\nnovdom_testing/component_should.show_text\nnovdom_testing/component_should show_text","url":"novdom_testing/component_should.html#show_text"},{"doc":"novdom_testing/component_should","title":"novdom_testing/component_should","content":" A module for testing novdom components. \\\n Use it in combination with `novdom_testing/testing` to test initilize tests and render components.","url":"novdom_testing/component_should.html"},{"doc":"novdom_testing/testing","title":"Callee","content":"pub opaque type Callee\n A type to check if a function was called.\n\nSynonyms:\nnovdom_testing/testing.Callee\nnovdom_testing/testing Callee","url":"novdom_testing/testing.html#Callee"},{"doc":"novdom_testing/testing","title":"ParameterFn","content":"pub type ParameterFn =\n  fn(fn(Event) -&gt; Nil) -&gt; Parameter\n A Type for a function that creates a parameter with a listener (e.g. `onclick`).\n\nSynonyms:\nnovdom_testing/testing.ParameterFn\nnovdom_testing/testing ParameterFn","url":"novdom_testing/testing.html#ParameterFn"},{"doc":"novdom_testing/testing","title":"call_callee","content":"pub fn call_callee(callee: Callee) -&gt; Nil\n Call a callee to later check if it was called (see `callee_count`).\n Use this function to simulate a function call.\nSynonyms:\nnovdom_testing/testing.call_callee\nnovdom_testing/testing call_callee","url":"novdom_testing/testing.html#call_callee"},{"doc":"novdom_testing/testing","title":"callee_count","content":"pub fn callee_count(callee: Callee) -&gt; Int\n Check how often a callee was called\nSynonyms:\nnovdom_testing/testing.callee_count\nnovdom_testing/testing callee_count","url":"novdom_testing/testing.html#callee_count"},{"doc":"novdom_testing/testing","title":"create_callee","content":"pub fn create_callee() -&gt; Callee\n Create a callee type that can be used to test if a function was called\nSynonyms:\nnovdom_testing/testing.create_callee\nnovdom_testing/testing create_callee","url":"novdom_testing/testing.html#create_callee"},{"doc":"novdom_testing/testing","title":"description","content":"pub fn description(\n  component: Component,\n  desc: String,\n) -&gt; Component\n Set a description for a component to be used in error messages\nSynonyms:\nnovdom_testing/testing.description\nnovdom_testing/testing description","url":"novdom_testing/testing.html#description"},{"doc":"novdom_testing/testing","title":"init","content":"pub fn init(test_fn: fn() -&gt; a) -&gt; Nil\n Initialize the testing environment. This function should be called at the beginning of a test.\nSynonyms:\nnovdom_testing/testing.init\nnovdom_testing/testing init","url":"novdom_testing/testing.html#init"},{"doc":"novdom_testing/testing","title":"render","content":"pub fn render(component: fn() -&gt; Component) -&gt; Nil\n Render a component in the viewport. This function should be called in a test function. \\\n **Warning:** Never use `novdom.start()` in a test function, this can lead to unexpected behavior.\nSynonyms:\nnovdom_testing/testing.render\nnovdom_testing/testing render","url":"novdom_testing/testing.html#render"},{"doc":"novdom_testing/testing","title":"step","content":"pub fn step(subject: a, step: String) -&gt; a\n Name a step in a test to make error messages more precise. This does only work with `novdom_testing/component_should` functions (not with `gleeunit/should`).\n \n Example:\n \n comp\n |&gt; step(&quot;Check if component is visible&quot;)\n |&gt; component_should.be_visible()\n \n \nSynonyms:\nnovdom_testing/testing.step\nnovdom_testing/testing step","url":"novdom_testing/testing.html#step"},{"doc":"novdom_testing/testing","title":"trigger_event","content":"pub fn trigger_event(\n  component: Component,\n  listener: fn(fn(Event) -&gt; Nil) -&gt; Parameter,\n) -&gt; Component\n Trigger an event on a component.\n\n Example for a click event:\n \n trigger_event(my_component, onclick)\n \n\nSynonyms:\nnovdom_testing/testing.trigger_event\nnovdom_testing/testing trigger_event","url":"novdom_testing/testing.html#trigger_event"},{"doc":"novdom_testing/testing","title":"trigger_replacement","content":"pub fn trigger_replacement(component: Component) -&gt; Component\n Trigger the `onreplacement` modifier on a component.\nSynonyms:\nnovdom_testing/testing.trigger_replacement\nnovdom_testing/testing trigger_replacement","url":"novdom_testing/testing.html#trigger_replacement"},{"doc":"novdom_testing/testing","title":"novdom_testing/testing","content":" A module for initializing tests and rendering components. \\\n Use it in combination with `novdom_testing/component_should` to test novdom components.","url":"novdom_testing/testing.html"}]);